<app-page-title [heading]="heading" [subheading]="subheading" [icon]="icon">
  <button (click)="openModal(modalForm);" class="btn btn-primary">
    <i class="fas fa-plus mr-2"></i>Nuevo
  </button>
  <button (click)="printPDF()" class="btn btn-danger ml-1" [disabled]="dataGrid.data.length === 0 || loading">
    <i class="fas fa-file-pdf mr-2"></i>PDF
  </button>
</app-page-title>

<div class="main-card mb-3 card">
  <div class="card-body">

    <div *ngIf="!loading">

      <kendo-grid [data]="dataGrid.data" [selectable]="true" [filter]="filter" [filterable]="true"
                  (filterChange)="filterChange($event)" [selectable]="true" [navigable]="true" [scrollable]="'virtual'"
                  [reorderable]="true" [resizable]="true" [sort]="sort" [sortable]="true"
                  (sortChange)="sortChange($event)"
                  [groupable]="true" [group]="groups" (groupChange)="groupChange($event)" (edit)="editRow($event)"
                  (remove)="deleteRow($event)" style="height: 75vh">
            <ng-template kendoGridToolbarTemplate>
              <button type="button" kendoGridExcelCommand icon="file-excel" [disabled]="dataGrid.data.length === 0"
               class="btn-success">Exportar Excel</button>
            </ng-template>
        <kendo-grid-column field="clase" title="Clase" width="200"></kendo-grid-column>
        <kendo-grid-column field="cdesc" title="Descripción"></kendo-grid-column>
        <kendo-grid-column field="civa" title="IVA" width="120" [filterable]="false">
          <ng-template kendoGridFilterCellTemplate>
            <kendo-switch (valueChange)="switchChange($event)" offLabel="No" [checked]="checked" onLabel="Si">
            </kendo-switch>
          </ng-template>
          <ng-template kendoGridCellTemplate let-dataItem>
            <input type="checkbox" [checked]="dataItem.civa" disabled/>
          </ng-template>
        </kendo-grid-column>
        <kendo-grid-column field="Inactivo" title="Inactivo" width="120">
          <ng-template kendoGridFilterCellTemplate>
            <kendo-switch (valueChange)="switchChange($event)" offLabel="No" [checked]="checked" onLabel="Si">
            </kendo-switch>
          </ng-template>
          <ng-template kendoGridCellTemplate let-dataItem>
            <input type="checkbox" [checked]="dataItem.Inactivo" disabled/>
          </ng-template>
        </kendo-grid-column>
        <kendo-grid-command-column title="Actions" width="190">
          <ng-template kendoGridCellTemplate let-isNew="isNew">
            <button kendoGridEditCommand [primary]="true">Editar</button>
            <button kendoGridRemoveCommand>Eliminar</button>
          </ng-template>
        </kendo-grid-command-column>
        <kendo-grid-excel fileName="{{this.heading}}.xlsx" [fetchData]="allData"></kendo-grid-excel>
      </kendo-grid>

    </div>
<app-loading *ngIf="loading"></app-loading>

  </div>
  <ng-template #modalForm let-c="close" let-d="dismiss">
    <div class="modal-header">
      <h4 *ngIf="!flagEdit">Nueva Clase</h4>
      <h4 *ngIf="flagEdit">Actualizar Clase</h4>
    </div>
    <div class="modal-body">
      <form [formGroup]="myFormGroup" class="k-form">
        <div class="row-fluid">
          <div class="row">
            <label class="k-form-field col-4">
              <span>Clase</span>
              <input type="text" class="form-control" formControlName="clase" [readOnly]="flagEdit" minlength="1"
                     maxlength="1">
            </label>
            <label class="k-form-field col-8">
              <span>Descripción</span>
              <input type="text" class="form-control" formControlName="cdesc" maxlength="30">
            </label>

          </div>
          <div class="row">
            <label class="k-form-field col-4">
              <span>IVA</span>
              <kendo-switch formControlName="civa" [onLabel]="'Si'" [offLabel]="'No'">
              </kendo-switch>
            </label>
            <label class="k-form-field col-4">
              <span>Servicio</span>
              <kendo-switch formControlName="cprop" [onLabel]="'Si'" [offLabel]="'No'">
              </kendo-switch>
            </label>
            <label class="k-form-field col-4">
              <span>Cuarto</span>
              <kendo-switch formControlName="ccuarto" [onLabel]="'Si'" [offLabel]="'No'">
              </kendo-switch>
            </label>
          </div>
          <div class="row">
            <label class="k-form-field col-4">
              <span>Descuento</span>
              <kendo-switch formControlName="cdescto" [onLabel]="'Si'" [offLabel]="'No'">
              </kendo-switch>
            </label>
            <label class="k-form-field col-4">
              <span>Procentaje</span>
              <input type="number" class="form-control" formControlName="cporc" min="-999.99" max="999.99"
                     [value]="myFormGroup.get('cporc').value | number : '1.2-2'">
            </label>
          </div>
          <div class="row">
            <label class="k-form-field col-4">
              <span>Cheque</span>
              <kendo-switch formControlName="ccheque" [onLabel]="'Si'" [offLabel]="'No'">
              </kendo-switch>
            </label>
            <label class="k-form-field col-4">
              <span>Inactivo</span>
              <kendo-switch formControlName="Inactivo" [onLabel]="'Si'" [offLabel]="'No'">
              </kendo-switch>
            </label>
          </div>
        </div>
      </form>
    </div>
    <div class="modal-footer">
      <button type="button" class="btn btn-shadow btn-primary" (click)="c('Close click');closeForm();">
        Cerrar
      </button>
      <button type="button" class="btn btn-shadow btn-success ml-1" [disabled]="myFormGroup.invalid"
              (click)="guardarForm()">Guardar
      </button>
    </div>
  </ng-template>
</div>
